<template>
  <section class="checkout-page two-col-page container">
    <div class="two-col-page__content">
      <h2 class="checkout-page__title">Оформление заказа</h2>

      <checkout-section :title="isAuthenticated ? 'Личные данные' : 'Авторизация'"
                        type="private"
                        :preview-items="privatePreviews"
                        :filled="isPrivateFilled"
                        v-if="showSection"
      >

        <checkout-auth v-if="!isAuthenticated" :rights="rights" />

        <ValidationObserver v-slot="{handleSubmit}" v-else ref="observer">
          <div class="checkout-page__private-inputs">

            <ValidationProvider
              class="checkout-page__private-input"
              v-slot="{errors}"
              name="name"
              rules="required">
              <form-input class=""
                          :error="Boolean(errors.length)"
                          :label="user.name ? 'Имя' : 'Введите имя'"
                          v-model="user.name"
                          name="name"
                          @blur="onBlurInput"
              />
            </ValidationProvider>

            <form-input class="checkout-page__private-input"
                        :label="user.surname ? 'Фамилия' : 'Введите фамилию'"
                        v-model="user.surname"
                        @blur="onBlurInput"
            />

            <ValidationProvider
              class="checkout-page__private-input"
              v-slot="{errors, failedRules}"
              name="email"
              rules="email|required">
              <form-input class=""
                          :error="Boolean(errors.length)"
                          :label="user.email ? failedRules.email ? failedRules.email : 'Email' : 'Введите email'"
                          v-model="user.email"
                          name="email"
                          :readonly="isEmailFilled"
                          @blur="onBlurInput('email')"
              />
            </ValidationProvider>

            <form-input class="checkout-page__private-input"
                        :label="user.phone ? 'Телефон' : 'Введите телефон'"
                        type="tel"
                        v-model="user.phone"
                        :mask="true"
                        mask-type="phone-mask"
                        :readonly="true"
            />
          </div>
        </ValidationObserver>

      </checkout-section>

      <div class="checkout-page__additional">
        <BaseTextarea v-if="isAuthenticated"
                      v-model="comment"
                      :label="isMaxLengthComment ? 'Комментарий слишком длинный' : 'Комментарий'"
                      :error="isMaxLengthComment"
        />

        <single-checkbox class="checkout-page__rights"
                         v-model="rights"
                         :error="!rights"
                         name="rights">
          Я согласен(-на) с условиями <a href="/user_agreement.pdf" target="_blank">договора об использовании платформы</a>
          и <a href="/privacy_policy.pdf" target="_blank">политикой обработки персональных данных</a>.
        </single-checkbox>
      </div>

      <checkout-section title="Бронирование"
                        type="book"
                        :preview-items="bookPreviews"
                        class="checkout-page__book"
                        :filled="isBookingsFilled"
                        @bookMore="onBookMore"
      >

        <schedule-with-calendar
          v-if="room.schedule"
          ref="schedule"
          :room="room"
          :hasTitle="false"
        />

      </checkout-section>

    </div>

    <div class="two-col-page__right checkout-page__right">
      <div class="checkout-room" v-if="room.id">
        <nuxt-link :to="`/places/${room.id}`" class="checkout-room__img">
          <img :src="room.images[0].url"
               :alt="room.name">
        </nuxt-link>

        <nuxt-link :to="`/places/${room.id}`" class="checkout-room__name">
          {{ room.name }}
        </nuxt-link>

        <ul class="checkout-room__reservations">
          <li class="checkout-room__reservation"
              v-for="booking in bookingItems"
              :key="booking.bookingId"
          >
            <span class="checkout-room__date">
              {{ weekDays[booking.date.getDay()].long }}, {{ booking.date.getDate() }} {{ months[booking.date.getMonth()] }}
            </span>

            <span class="checkout-room__time">
              {{ booking.timeFrom.label }}–{{booking.timeTo.label}}
            </span>
            <span class="checkout-room__price">{{ booking.price | rubCurrency }}</span>

            <span class="checkout-room__cross"
                  @click="() => removeBookingRow(booking.bookingId)">
              <icon-cross/>
            </span>
          </li>
        </ul>
      </div>

      <div class="checkout-page__total" v-if="bookingsPrice">
        <span class="checkout-page__total-label">Итого:</span>
        <span class="checkout-page__total-price">{{ bookingsPrice | rubCurrency }}</span>
      </div>

      <base-select class="checkout-page__pay-type"
                   :options="selectOptions"
                   :value="payType"
                   label="Способ оплаты"
                   @onSelect="changePayType"
      />

      <button type="button"
              class="button button--green checkout-page__btn"
              @click="onClickPayBtn"
              :disabled="orderDisabled">
        Оплатить
      </button>
    </div>
  </section>
</template>

<script>
  import {ValidationObserver, ValidationProvider} from 'vee-validate';
  import { mapGetters, mapMutations, mapActions } from 'vuex';

  import IconCross from '../../components/icons/IconCross';
  import BaseSelect from '../../components/BaseSelect';
  import CheckoutSection from '../../components/CheckoutSection';
  import CheckoutAuth from '../../components/CheckoutAuth';
  import FormInput from '../../components/FormInput';
  import SingleCheckbox from '../../components/SingleCheckbox';
  import Schedule from '../../components/Schedule';
  import ScheduleWithCalendar from '../../components/ScheduleWithCalendar';
  import BaseTextarea from "~/components/BaseTextarea";

  import {
    getSeoBySlug,
    getRoom,
    createOrder,
    getPaymentLink,
  } from '../../service/deliroom-service';
  import { months, weekDays } from '../../assets/js/helpers/consts';

  export default {
    name: 'CheckoutPage',
    components: {
      ValidationObserver,
      ValidationProvider,

      ScheduleWithCalendar,
      Schedule,
      SingleCheckbox,
      FormInput,
      CheckoutAuth,
      CheckoutSection,
      BaseSelect,
      IconCross,
      BaseTextarea
    },
    data: () => ({
      rights: true,
      payType: null,
      room: {},
      weekDays: weekDays,
      months: months,
      user: {
        name: null,
        surname: null,
        email: null,
        phone: null,
      },
      comment: '',
      payBtnClicked: false,
      showSection: true,
      saveUserStatus: ''
    }),

    asyncData: async ({ params, redirect }) => {
      const room = await getRoom(params.id);

      if (!room) {
        redirect('/404');
        return;
      }

      return {
        meta: await getSeoBySlug('/checkout'),
        room,
      }
    },

    validate({ params }) {
      return /^\d+$/.test(params.id)
    },

    beforeMount() {
      this.user = { ...this.$store.state.user.user }
    },

    mounted() {
      this.refreshSection()
    },

    watch: {
      userInStore() {
        this.user = { ...this.$store.state.user.user }
      }
    },

    computed: {
      ...mapGetters({
        isAuthenticated: 'auth/isAuthenticated',
        balance: 'user/balance'
      }),

      orderDisabled() {
        return !(this.isBookingsFilled && this.isPrivateFilled && this.payType && this.rights && !this.isMaxLengthComment) || this.payBtnClicked
      },

      userInStore() {
        return this.$store.state.user.user;
      },

      selectOptions() {
        const result = [{ value: 'card', label: 'Банковской картой' }];

        if (this.balance) {
          result.push({ value: 'inner', label: `Внутренний счет ${this.balance} ₽` })
        }

        return result;
      },

      bookingItems() {
        const currentBookings = this.$store.state.schedule.bookings.filter((booking) => booking.roomId === this.room.id)[0];
        if (!currentBookings) return [];

        return currentBookings.bookingItems.filter((booking) => !booking.ordered);
      },

      bookingsPrice() {
        const currentBookings = this.$store.state.schedule.bookings.filter((booking) => booking.roomId === this.room.id)[0];

        if (!currentBookings) return null;

        let price = 0;

        let totalPrice = currentBookings.bookingItems
          .reduce((accumulator, currentValue) => {
            if (!currentValue.ordered)
              return accumulator + currentValue.price;
            else
              return accumulator
          }, price);

        if (totalPrice) {
          return totalPrice;
        }
      },

      bookPreviews() {
        let result = [];

        result = this.bookingItems.map((booking) =>
          `<b>${ this.weekDays[booking.date.getDay()].short} ${booking.date.getDate()} ${this.months[booking.date.getMonth()]}</b>
                  ${booking.timeFrom.label}–${booking.timeTo.label}`
        );

        return result;
      },

      privatePreviews() {
        let result = [];

        result = [
          `${this.user.name} ${this.user.surname}`,
          this.user.email,
          this.user.phone ? this.getMaskedPhone(this.user.phone) : ''
        ];

        return result;
      },

      isPrivateFilled() {
        return !!this.user.name && !!this.user.email && !!this.user.phone;
      },

      isBookingsFilled() {
        return Boolean(this.bookingItems.length);
      },

      isEmailFilled() {
        return !!this.$store.state.user.user.email;
      },

      isMaxLengthComment() {
        return this.comment.length > 255
      }
    },

    methods: {
      ...mapMutations({
        removeBooking: 'schedule/removeBooking',
      }),

      ...mapActions({
        saveUser: 'user/saveUser',
        getAccountInfo: 'user/getAccountInfo'
      }),

      refreshSection() {
        this.showSection = false

        this.$nextTick(() => {
          this.showSection = true
        })
      },

      removeBookingRow(id) {
        this.removeBooking({ roomId: this.room.id, bookingId: id })
      },

      changePayType(event) {
        this.payType = event.value;
      },

      getMaskedPhone(phone) {
        return phone.replace(/(\d{3})(\d{3})(\d{2})(\d{2})/, '+7 ($1) $2-$3-$4');
      },

      async onBlurInput() {
        this.saveUserStatus = 'started';
        this.$refs.observer.reset();
        const valid = await this.$refs.observer.validate();

        if (!valid) return;

        if (!this.rights) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: 'Не дано согласие на обработку данных',
          });

          return;
        }

        await this.saveUser(this.user);

        this.saveUserStatus = 'end';
      },

      async onClickPayBtn() {
        if (!this.rights) return;
        if (this.saveUserStatus === 'started') return;

        this.payBtnClicked = true;

        const createdOrder = await createOrder({
          place_id: this.room.id,
          comment: this.comment
        });

        if (createdOrder.message || createdOrder.data.errors) {
          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: createdOrder.message || createdOrder.data.errors[0],
          });

          this.payBtnClicked = false;

          return;
        }

        const payMethod = this.payType === 'card' || this.payType === null ? 1 : 2;

        const paymentLink = await getPaymentLink(createdOrder.data.id, { method: payMethod });


        this.$gtm.push({ event: 'order' });

        if (paymentLink.message || paymentLink.data.errors) {

          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: paymentLink.message || paymentLink.data.errors[0],
          });

          this.$router.push('/personal/orders');

        } else {

          if (paymentLink.data.payment_link) {
            window.location.href = paymentLink.data.payment_link;
          } else {
            await this.getAccountInfo();

            this.$router.push('/personal/orders');
          }

        }
      },

      getBalance(events) {
        if (events.length <= 0) return 0;

        return `${Math.abs(events[events.length - 1].value)}`
      },

      onBookMore() {
        this.$refs.schedule.addScheduleRow();
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .checkout-page {
    margin-top: rem(40);
    margin-bottom: rem(20);
    counter-reset: checkoutSections;

    @media (max-width: $mobile-width) {
      margin-top: rem(16);
    }

    &__title {
      @include h2;
      margin-bottom: rem(50);

      @media (max-width: $mobile-width) {
        display: none;
      }
    }

    &__right {
      @media (max-width: $mobile-width) {
        margin-top: rem(24);
      }
    }

    .checkout-room {
      &__img {
        display: block;
        width: 100%;
        height: rem(164);
        margin-bottom: rem(20);

        border-radius: rem(8);
        overflow: hidden;

        @media (max-width: $mobile-width) {
          height: rem(180);
        }

        img {
          width: 100%;
          height: 100%;

          object-fit: cover;
        }
      }

      &__name {
        @include p1;
        margin-bottom: rem(4);

        &:hover {
          color: $green;
        }
      }

      &__reservations {
        margin-bottom: rem(24);
      }

      &__reservation {
        display: flex;
        flex-flow: wrap;
        justify-content: space-between;
        padding: rem(20) 0 rem(22);

        & + .checkout-room__reservation {
          border-top: rem(1) solid #DCE2EF;
        }

        &:last-child {
          border-bottom: rem(1) dashed #DCE2EF;
        }
      }

      &__date {
        flex: 1 1 100%;
        width: 100%;
        margin-bottom: rem(8);

        font-size: rem(12);
        line-height: rem(16);
        color: rgba($black, .6);
      }

      &__time,
      &__price {
        @include bold-black-link;
        line-height: rem(18);
      }

      &__cross {
        position: absolute;
        top: rem(20);
        right: rem(-8);

        svg {
          height: rem(24);
          width: rem(24);

          padding: rem(8);
          cursor: pointer;

          &:hover {
            stroke: $green;
          }
        }
      }
    }

    &__total {
      @include p1;

      display: flex;
      align-items: center;
      justify-content: space-between;
      margin: rem(24) 0;
    }

    &__total-label {
      color: rgba($black, .5);
    }

    &__pay-type {
      margin: rem(24) 0;
    }

    &__btn {
      width: 100%;
    }

    &__rights {
      margin-top: rem(36);

      .checkbox__label {
        max-width: rem(440);
      }
    }

    &__private-inputs {
      display: flex;
      flex-flow: wrap;

      margin: rem(-14);

      @media (max-width: $mobile-width) {
        margin: 0;
      }
    }

    &__private-input {
      flex: 0 0 calc(50% - 1.75rem);
      width: calc(50% - 1.75rem);
      margin: rem(14);

      @media (max-width: $mobile-width) {
        flex: 0 0 100%;
        width: 100%;
        margin: rem(14) 0;
      }
    }

    &__book {
      .schedule-row:first-child {
        padding-top: 0;
      }

      .checkout-page__schedule {
        margin-bottom: rem(60);

        @media (max-width: $mobile-width) {
          margin-top: rem(44);
        }
      }
    }

    &__additional {
      margin: rem(32) auto;
    }
  }
</style>

